From bdfb7a5d22f8d7ff46a2a10aa019f9e57b0ad5cf Mon Sep 17 00:00:00 2001
From: Jean-Baptiste Holcroft <jean-baptiste@holcroft.fr>
Date: Jun 17 2019 20:44:49 +0000
Subject: [PATCH 9/10] add territory-language consistency check using population data


---

diff --git a/build_stats.py b/build_stats.py
index 42ea48e..8ac14d3 100755
--- a/build_stats.py
+++ b/build_stats.py
@@ -76,6 +76,9 @@ def parse(concat):
     data = clean_cldr(data)
     info(data, "cldr data are cleaned")
 
+    data = check_lang_territory_consistency(data)
+    info(data, "cldr consistency are done")
+
     store(data, "3.result.csv")
 
 
@@ -244,6 +247,37 @@ def clean_cldr(data):
 
     return data
 
+def check_lang_territory_consistency(data):
+    """ use pop per lang_script and territory to detect potential errors """
+
+    cldr_data = pandas.read_csv("CLDR-raw/country_language_population_raw.txt",
+                                sep="\t")
+    cldr_data.CName = cldr_data.CName.str.lower()
+
+    # in this file, Azerbaijani (Arabic) is written az_Arab, we only keep lang for now
+    cldr_data['Language'] = cldr_data['Language'].str.rsplit('_', 1, expand=True)[0]
+
+
+    cldr_data = cldr_data[["CName", 'Language']]
+    # as we may have duplicated values now
+    cldr_data = cldr_data.drop_duplicates()
+    cldr_data = cldr_data.rename(columns={'CName':'territory', 'Language':'language'})
+
+    data = data.merge(cldr_data, how='left',
+                      left_on=('language','region'),
+                      right_on=('language','territory'),
+                      suffixes=(False,'_cldr'))
+    data = data.rename(columns={'name': 'language_name'})
+
+    error = data[['language', 'region', 'territory']]
+    error = error[~(error.region.isnull())]
+    error = error[~(error.region == '')]
+    error = error[error.territory.isnull()].drop_duplicates()
+    store(error, '0.error.no population for this language-territory couple.csv')
+
+    data = data.drop('territory', 1)
+
+    return data
 
 def info(dataset, step):
     """Print basic informations about current dataset"""
diff --git a/results/f30/0.error.no population for this language-territory couple.csv b/results/f30/0.error.no population for this language-territory couple.csv
new file mode 100644
index 0000000..27c72fb
--- /dev/null
+++ b/results/f30/0.error.no population for this language-territory couple.csv
@@ -0,0 +1,2 @@
+language,region,territory
+an,es,

